#version 120
#extension GL_ARB_texture_rectangle : enable
uniform sampler2DRect video;
uniform float maskZoom; 
uniform float maskX; 
uniform float maskY; 
uniform float videoW; 
uniform float videoH; 
uniform float imgW; 
uniform float imgH; 
uniform float solidColorBrightness;
varying vec2 texCoordVarying;

void main()
{
	vec4 solidColor = vec4(solidColorBrightness,solidColorBrightness,solidColorBrightness,1);
	vec2 center = vec2(videoW,videoH)/2.0; 
	vec2 coord = texCoordVarying*videoW/imgW*maskZoom+center+vec2(maskX*videoW/2,maskY*videoH/2);
	vec4 videoColor = texture2DRect(video, coord);

	float mixVideo = gl_Color.r; 
	float mixSolid = gl_Color.g; 
	
	float alpha = mixVideo/max(mixVideo+mixSolid,0.01); 
	
	gl_FragColor = videoColor*alpha + solidColor*(1-alpha);
	gl_FragColor.a = gl_Color.b; 
}